import java.io.*;

public class MaartenNoMemo {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenNoMemo().run(reader);
        }
    }

    public void run(BufferedReader reader) throws IOException {
        String[] firstLine = reader.readLine().split(" ");
        int t = Integer.parseInt(firstLine[0]);
        int p = Integer.parseInt(firstLine[1]);

        int[][] times = new int[t][p];

        for (int i = 0; i < t; i++) {
            String[] xs = reader.readLine().split(" ");
            int j = 0;
            for (String x : xs) {
                times[i][j++] = x.equals("X") ? -1 : Integer.parseInt(x);
            }
        }

        int cakes = 0;
        for (int i = 1; i < t; i++) {
            if (numProblems(times[i]) > numProblems(times[0]) ||
                    numProblems(times[i]) == numProblems(times[0]) && sumTimes(times[i]) <= sumTimes(times[0]))
                cakes++;
        }
        System.out.println(cakes);
    }

    public int numProblems(int[] times) {
        int count = 0;
        for (int time : times) {
            if (time > -1) count++;
        }
        return count;
    }

    public int sumTimes(int[] times) {
        int count = 0;
        for (int time : times) {
            if (time > -1) count += time;
        }
        return count;
    }
}
